#include "part2.h"
#include <fstream>


std::istream& operator >>(std::istream& in, account& p_acc) {
    std::string buf;
    std::cout << "Account number: ";
    in >> p_acc.number;
    std::cout << "Account code:";
    in >> p_acc.code;
    std::cout << "Surname: ";
    in >> p_acc.surname;
    std::cout << "Money balance: ";
    in >> p_acc.money;
    std::cout << "Account creation date: ";
    in >> p_acc.creation_date;
    std::cout << "Annual percentage: ";
    in >> p_acc.annual_percentage;
    return in;
}

std::ostream& operator <<(std::ostream& out, account& p_acc) {
    out <<
        "Account number: " << p_acc.number << std::endl <<
        "Account code: " << p_acc.code << std::endl <<
        "Surname: " << p_acc.surname << std::endl <<
        "Money balance: " << p_acc.money << std::endl <<
        "Account creation date: " << p_acc.creation_date << std::endl <<
        "Annual percentage: " << p_acc.annual_percentage << "%" << std::endl;
    return out;
}


void general::load_in()
{
    accounts_map.clear();
    s = 0;
    
    
    std::ifstream in; //!!! Использовать надо ifstream или ofstream
                      // ~~~ исправил
    
    
    
    
    in.open("accounts_data.bin", std::ios::binary);
    if (!in.is_open())
        return;
    account cur;
    while (in.read((char*)(&cur), sizeof(account)))
    {
        s++;
        accounts_map.insert({ s, cur });
    }
    in.close();
}

void general::load_out()
{
    std::ofstream out("accounts_data.bin", std::ios::binary);
    std::map<size_t, account>::iterator iter = accounts_map.begin();

    while (iter != accounts_map.end())
    {
        out.write(reinterpret_cast<char*>(&iter->second), sizeof(account));
        iter++;
    }
    out.close();
}

general::general()
{
    load_in();
}

general::~general()
{
    load_out();
    accounts_map.clear();
}


void general::add_account(account& p)
{
    s++;
    std::pair<size_t, account> c_p(s, p);
    accounts_map.insert(c_p);
    load_out();
}

bool general::search_account_number(const int p)
{
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
        {
            return p2.second.number == p;
        });
    if (res == accounts_map.end())
    {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != accounts_map.end())
    {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(account));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
            {
                return p2.second.number == p;
            });
    }
    fout.close();
    return true;
}

bool general::search_account_code(const int p)
{
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
        {
            return p2.second.code == p;
        });
    if (res == accounts_map.end())
    {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != accounts_map.end())
    {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(account));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
            {
                return p2.second.code == p;
            });
    }
    fout.close();
    return true;
}
bool general::search_account_surname(const std::string& p)
{
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
        {
            return p2.second.surname == p;
        });
    if (res == accounts_map.end())
    {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != accounts_map.end())
    {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(account));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
            {
                return p2.second.surname == p;
            });
    }
    fout.close();
    return true;
}

bool general::search_account(const account& p)
{
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
        {
            return p2.second == p;
        });
    if (res == accounts_map.end())
    {
        return false;
    }
    std::ofstream out_("Log.bin", std::ios::binary);
    while (res != accounts_map.end())
    {
        out_.write(reinterpret_cast<char*>(&res->second), sizeof(account));
        std::cout << std::endl <<  res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
            {
                return p2.second == p;
            });
    }
    out_.close();
    return true;
}

bool general::delete_account(const account& p)
{
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
        {
            return p2.second == p;
        });
    if (res == accounts_map.end())
    {
        return false;
    }
    while (res != accounts_map.end())
    {
        res = accounts_map.erase(res);
        s--;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, account>& p2)
            {
                return p2.second == p;
            });
    }
    load_out();
    return true;
}

bool general::change_account(const account& p1, const account& p2)
{
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(), [&p1](const std::pair<size_t, account>& p2)
        {
            return p2.second == p1;
        });
    if (res == accounts_map.end())
    {
        return false;
    }
    while (res != accounts_map.end())
    {
        res->second = p2;
        s--;
        res = std::find_if(res, accounts_map.end(), [&p1](const std::pair<size_t, account>& p2)
            {
                return p2.second == p1;
            });
    }
    load_out();
    return true;
}


void general::load_out_txt()
{
    auto iter = accounts_map.begin();
    double money_sum = 0;
    double average_percentage = 0;
    int i = 1;

    std::ofstream txt_out("Out_data.txt");

    
    //!!! По заданию в текстовый файл должна выводиться отформатированная таблица с шапкой.
    //!!! Шапка должна создаваться с использованием манипуляторой.
    // ~~~ исправил
    txt_out << std::setw(15) <<
        "Account number" << "|" << std::setw(15) <<
        "Account code" << "|" << std::setw(15) <<
        "Surname" << "|" << std::setw(15) <<
        "Money balance" << "|" << std::setw(25) <<
        "Account creation date" << "|" << std::setw(15) <<
        "Annual percentage" << std::endl << std::string(107, '-') << std::endl;


    while (iter != accounts_map.end())
    {
        money_sum += iter->second.money;
        average_percentage += iter->second.annual_percentage;
        txt_out << std::setw(15) <<
            iter->second.number << "|" << std::setw(15) <<
            iter->second.code << "|" << std::setw(15) <<
            iter->second.surname << "|" << std::setw(15) <<
            iter->second.money << "|" << std::setw(25) <<
            iter->second.creation_date << "|" << std::setw(15) <<
            iter->second.annual_percentage << "%" << std::endl;
        iter++;
    }

    txt_out << std::endl << std::endl <<  "Total amount of accounts: " << accounts_map.size() << std::endl <<
        "Money sum on all accounts: " << money_sum << std::endl <<
        "Average annual percentage: " << round(average_percentage / accounts_map.size() * 100) / 100 << "%" << std::endl;
    txt_out.close();
}